package com.mortals.xhx.module.perform.web;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.code.AssessmentScopeEnum;
import com.mortals.xhx.module.perform.model.*;
import com.mortals.xhx.module.perform.service.PerformPerposeDeptService;
import com.mortals.xhx.module.perform.service.PerformPerposeStaffService;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.perform.service.PerformPerposeService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSONObject;

import java.util.Arrays;

import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import static com.mortals.framework.ap.SysConstains.*;

/**
 * 考核目标
 *
 * @author zxfei
 * @date 2023-05-16
 */
@RestController
@RequestMapping("perform/perpose")
public class PerformPerposeController extends BaseCRUDJsonBodyMappingController<PerformPerposeService, PerformPerposeEntity, Long> {

    @Autowired
    private ParamService paramService;
    @Autowired
    private UserService userService;

    @Autowired
    private PerformPerposeStaffService perposeStaffService;
    @Autowired
    private PerformPerposeDeptService perposeDeptService;

    public PerformPerposeController() {
        super.setModuleDesc("考核目标");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "assessmentType", paramService.getParamBySecondOrganize("PerformPerpose", "assessmentType"));
        this.addDict(model, "assessmentScope", paramService.getParamBySecondOrganize("PerformPerpose", "assessmentScope"));
        this.addDict(model, "compareScope", paramService.getParamBySecondOrganize("PerformPerpose", "compareScope"));
        this.addDict(model, "periodType", paramService.getParamBySecondOrganize("PerformPerpose", "periodType"));
        this.addDict(model, "month", paramService.getParamBySecondOrganize("PerformPerpose", "month"));
        this.addDict(model, "halfYear", paramService.getParamBySecondOrganize("PerformPerpose", "halfYear"));
        this.addDict(model, "halfYear", paramService.getParamBySecondOrganize("PerformPerpose", "halfYear"));
        this.addDict(model, "quarter", paramService.getParamBySecondOrganize("PerformPerpose", "quarter"));


        Map<String, String> collect = userService.find(new UserQuery(), getContext()).stream()
                .collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getRealName(), (o, n) -> n));
        this.addDict(model, "updateUserId", collect);

        super.init(model, context);
    }


    @Override
    protected void doListBefore(PerformPerposeEntity query, Map<String, Object> model, Context context) throws AppException {
        super.doListBefore(query, model, context);

        if (ObjectUtils.isEmpty(query.getOrderColList())) {
            query.setOrderColList(Arrays.asList(new OrderCol("createTime", OrderCol.DESCENDING)));
        } else {
            query.getOrderColList().add(new OrderCol("createTime", OrderCol.DESCENDING));
        }

    }

    @Override
    protected int editAfter(Long id, Map<String, Object> model, PerformPerposeEntity entity, Context context) throws AppException {

        if (AssessmentScopeEnum.个人.getValue() == entity.getAssessmentScope()) {
            List<PerformPerposeStaffEntity> staffEntities = perposeStaffService.find(new PerformPerposeStaffQuery().purposeConfId(entity.getId()));
            entity.setPerposeStaffList(staffEntities);

        } else if (AssessmentScopeEnum.部门.getValue() == entity.getAssessmentScope()) {
            List<PerformPerposeDeptEntity> deptEntities = perposeDeptService.find(new PerformPerposeDeptQuery().purposeConfId(entity.getId()));
            entity.setPerposeDeptList(deptEntities);
        }

        return super.editAfter(id, model, entity, context);
    }
}